From a3cb8a671891ba524cba1749b7060c11a10a4009 Mon Sep 17 00:00:00 2001
From: Philip McGrath <philip@philipmcgrath.com>
Date: Fri, 3 Dec 2021 12:04:34 -0500
Subject: [PATCH] patch webpack.config.js for Guix

(cherry picked from commit 84a5d2aa62300f6039ffd13df30b9a612bfa505e)
---
 package.json      |  1 +
 webpack.config.js | 54 ++++++++++++++++++++++++++++++++++++++++-------
 2 files changed, 47 insertions(+), 8 deletions(-)

diff --git a/package.json b/package.json
index bd4af389..3561289b 100644
--- a/package.json
+++ b/package.json
@@ -29,6 +29,7 @@
   },
   "homepage": "https://webthings.io",
   "dependencies": {
+    "esbuild-loader": "*",
     "@fluent/bundle": "^0.16.0",
     "@fluent/dom": "^0.7.0",
     "@jest/console": "^26.6.2",
diff --git a/webpack.config.js b/webpack.config.js
index 55d43902..82a3f9f4 100644
--- a/webpack.config.js
+++ b/webpack.config.js
@@ -2,15 +2,23 @@
  * Wepback configuration for the node server.
  */
 
-const { CleanWebpackPlugin } = require('clean-webpack-plugin');
+//const { CleanWebpackPlugin } = require('clean-webpack-plugin');
 const CopyWebpackPlugin = require('copy-webpack-plugin');
 const HtmlWebpackPlugin = require('html-webpack-plugin');
-const ImageMinimizerWebpackPlugin = require('image-minimizer-webpack-plugin');
+//const ImageMinimizerWebpackPlugin = require('image-minimizer-webpack-plugin');
 const MiniCssExtractPlugin = require('mini-css-extract-plugin');
 const path = require('path');
-const { v1: uuidv1 } = require('uuid');
+//const { v1: uuidv1 } = require('uuid');
 const webpack = require('webpack');
 
+const ESBUILD_TARGET = "es2018";
+
+const { ESBuildMinifyPlugin } = require('esbuild-loader');
+// If your CSS is extracted and emitted as a CSS file, you can replace
+// CSS minification plugins like css-minimizer-webpack-plugin or
+// optimize-css-assets-webpack-plugin with the same
+// ESBuildMinifyPlugin by enabling the css option.
+/*
 const babelOptions = {
   presets: [
     [
@@ -32,10 +40,11 @@ const babelOptions = {
   ],
 };
 
+*/
 const pluginsWeb = [
-  new CleanWebpackPlugin({
-    cleanOnceBeforeBuildPatterns: ['**/*', '!service-worker.js*'],
-  }),
+  //new CleanWebpackPlugin({
+  //  cleanOnceBeforeBuildPatterns: ['**/*', '!service-worker.js*'],
+  //}),
   new CopyWebpackPlugin({
     patterns: [
       {
@@ -51,11 +60,13 @@ const pluginsWeb = [
       },
     ],
   }),
+  /*
   new ImageMinimizerWebpackPlugin({
     minimizerOptions: {
       plugins: ['gifsicle', 'jpegtran', 'optipng', 'svgo'],
     },
   }),
+  */
   new webpack.SourceMapDevToolPlugin({
     test: /\.css$/,
     filename: '[file].map',
@@ -137,6 +148,11 @@ const webpackWeb = {
   mode: 'production',
   target: 'web',
   optimization: {
+    minimizer: [
+      new ESBuildMinifyPlugin({
+        target: ESBUILD_TARGET
+      })
+    ],
     splitChunks: {
       cacheGroups: {
         styles: {
@@ -158,10 +174,17 @@ const webpackWeb = {
       {
         test: /.\/static\/js\/.*\.ts$/,
         include: path.resolve(__dirname, 'static'),
+        /*
         loader: 'ts-loader',
         options: {
           onlyCompileBundledFiles: true,
         },
+        */
+        loader: 'esbuild-loader',
+        options: {
+          loader: 'ts',
+          target: ESBUILD_TARGET
+        },
       },
       {
         test: [/.\/node_modules\/@fluent\/.*\.js$/, /.\/static\/js\/.*\.js$/],
@@ -170,9 +193,16 @@ const webpackWeb = {
           path.resolve(__dirname, 'static'),
         ],
         use: {
+          /*
           loader: 'babel-loader',
           options: babelOptions,
-        },
+          */
+          loader: 'esbuild-loader',
+          options: {
+            target: ESBUILD_TARGET,
+            format: 'cjs'
+          }
+        }
       },
       {
         test: /\.css$/,
@@ -222,12 +252,13 @@ const webpackWeb = {
     fallback: {
       fs: false,
     },
+    symlinks: false
   },
 };
 
 const pluginsSW = [
   new webpack.BannerPlugin({
-    banner: `const VERSION = '${uuidv1()}';`,
+    banner: `const VERSION = 'GUIX_SUBSTITUTE_UUID_HERE';`,
     raw: true,
   }),
 ];
@@ -248,8 +279,15 @@ const webpackSW = {
         test: /\.js$/,
         include: path.resolve(__dirname, 'static'),
         use: {
+          /*
           loader: 'babel-loader',
           options: babelOptions,
+          */
+          loader: 'esbuild-loader',
+          options: {
+            target: ESBUILD_TARGET,
+            format: 'cjs'
+          }
         },
       },
     ],
-- 
2.32.0

